<?php
namespace Teknisa\CADCTB\Controllers;

use Teknisa\CADCTB\Services\Ger02900ParametrosContabilizacaoService;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use \Teknisa\Libs\Util\NewCode;
use Zeedhi\Framework\DTO\Response\Error;

class Ger02900ParametrosContabilizacaoController extends \Teknisa\CADCTB\Controllers\TeknisaCrud {

    protected $dataSourceName = "";
    protected $dataSourceNameToSave = "";
    protected $parameterBagColumns = array();
    protected $newCode;
    protected $parametrosService;

    public function __construct($crudService, ParameterBag $parameterBag, NewCode $newCode, Ger02900ParametrosContabilizacaoService $parametrosService) {
        $this->parametrosService = $parametrosService;
        $this->newCode = $newCode;
        parent::__construct($crudService, $parameterBag);
    }
    
    public function geraNovoCodigo($contador, $nrorg){
        try {
            return $this->newCode->getCodeByTableName($contador, $nrorg);
        }catch (\Exception $e) {
            throw $e;
        }
    }

    public function findTipooperacHistpadrContctbl(DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName = "tipooperac_histpadr_contctbl";
        $this->parameterBagColumns = array("IDENTRSAIDOP", "NRORG");
        parent::find($request, $response);
    }

    public function saveTipooperacHistpadrContctbl(DTO\Request $request, DTO\Response $response) {
        $this->dataSourceName = "tipooperac_histpadr_contctbl";
        parent::save($request, $response);
    }

    public function findCtbprtpoperProdutoContctbl(DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName = "ctbprdtpoper_produto_contctbl";
        $this->parameterBagColumns = array("IDENTRSAIDOP", "CDTIPOOPER", "NRORG");
        parent::find($request, $response);
    }

    public function saveCtbprtpoperProdutoContctbl(DTO\Request $request, DTO\Response $response) {
        try {
            $row = $request->getDataSet()->getRows()[0];
            $row['__is_new'] = $this->parametrosService->ctbprdtpoperIsNew($row);
            $this->dataSourceName = "ctbprdtpoper_produto_contctbl";
            $this->dataSourceNameToSave = "ctbprdtpoper";
            parent::save($request, $response);
        } catch(\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    }

    public function findImpostoContctbl(DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName = "imposto_contctbl";
        parent::find($request, $response);
    }

    public function saveImpostoContctbl(DTO\Request $request, DTO\Response $response) {
        $this->dataSourceName = "imposto_contctbl";
        parent::save($request, $response);
    }

    public function findParamimpostofilImpostoContctbl(DTO\Request\Filter $request, DTO\Response $response) {
        try {
            $filter = $this->getFilterArray($request);
            $this->parametrosService->validateParamimpostofilFilter($filter);
            $this->dataSourceName = "paramimpostofil_imposto_contctbl";
            $this->parameterBagColumns = array("CDFILIAL", "IDENTRSAIDOP", "CDTIPOOPER", "NRORG");
            parent::find($request, $response);
        } catch(\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    }

    public function saveParamimpostofilImpostoContctbl(DTO\Request $request, DTO\Response $response) {
        try {
            $row = $request->getDataSet()->getRows()[0];
            $row['__is_new'] = $this->parametrosService->paramimpostofilIsNew($row);
            $this->dataSourceName = "paramimpostofil_imposto_contctbl";
            $this->dataSourceNameToSave = "paramimpostofil";
            parent::save($request, $response);
        } catch(\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    }

    public function findCtbimptpoperImpostoContctbl(DTO\Request\Filter $request, DTO\Response $response) {
        try {
            $filter = $this->getFilterArray($request);
            $this->parametrosService->validateCtbimptpoperFilter($filter);
            $this->dataSourceName = "ctbimptpoper_imposto_contctbl";
            $this->parameterBagColumns = array("IDENTRSAIDOP", "CDTIPOOPER", "NRORG");
            parent::find($request, $response);
        } catch(\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    }

    public function saveCtbimptpoperImpostoContctbl(DTO\Request $request, DTO\Response $response) {
        try {
            $row = $request->getDataSet()->getRows()[0];
            $row['__is_new'] = $this->parametrosService->ctbimptpoperIsNew($row);
            $this->dataSourceName = "ctbimptpoper_imposto_contctbl";
            $this->dataSourceNameToSave = "ctbimptpoper";
            parent::save($request, $response);
        } catch(\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    }

    public function findEncargoContctbl(DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName = "encargo_contctbl";
        $this->parameterBagColumns = array("NRORG");
        parent::find($request, $response);
    }

    public function saveEncargoContctbl(DTO\Request $request, DTO\Response $response) {
        $this->dataSourceName = "encargo_contctbl";
        parent::save($request, $response);
    }

    public function findProdutoHistpadrContctbl(DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName = "produto_histpadr_contctbl";
        $this->parameterBagColumns = array("NRORG");
        parent::find($request, $response);
    }

    public function saveProdutoHistpadrContctbl(DTO\Request $request, DTO\Response $response) {
        $this->dataSourceName = "produto_histpadr_contctbl";
        parent::save($request, $response);
    }

    public function findProdfiliProdutoContctbl(DTO\Request\Filter $request, DTO\Response $response) {
        try {
            $filter = $this->getFilterArray($request);
            $this->parametrosService->validateProdfiliFilter($filter);
            $this->dataSourceName = "prodfili_produto_contctbl";
            $this->parameterBagColumns = array("CDFILIAL", "NRORG");
            parent::find($request, $response);
        } catch(\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    }

    public function saveProdfiliProdutoContctbl(DTO\Request $request, DTO\Response $response) {
        try {
            $row = $request->getDataSet()->getRows()[0];
            $row['__is_new'] = $this->parametrosService->prodfiliIsNew($row);
            $this->dataSourceName = "prodfili_produto_contctbl";
            $this->dataSourceNameToSave = "prodfili";
            parent::save($request, $response);
        } catch(\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    }

    public function findTiporetiHistpadrContctbl(DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName = "tiporeti_histpadr_contctbl";
        $this->parameterBagColumns = array("NRORG");
        parent::find($request, $response);
    }

    public function saveTiporetiHistpadrContctbl(DTO\Request $request, DTO\Response $response) {
        $this->dataSourceName = "tiporeti_histpadr_contctbl";
        parent::save($request, $response);
    }

    public function findTipoctpagarHistpadrContctbl(DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName = "tipoctpagar_histpadr_contctbl";
        $this->parameterBagColumns = array("NRORG");
        parent::find($request, $response);
    }

    public function saveTipoctpagarHistpadrContctbl(DTO\Request $request, DTO\Response $response) {
        try {
            $row = $request->getDataSet()->getRows()[0];
            $this->parametrosService->validarTipoctpagar($row);
            $this->dataSourceName = "tipoctpagar_histpadr_contctbl";
            parent::save($request, $response);
        } catch(\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    }

    public function findTipoctpagarfiliTipoctpagarContctbl(DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName = "tipoctpagarfili_tipoctpagar_contctbl";
        $this->parameterBagColumns = array("CDFILIAL", "NRORG");
        parent::find($request, $response);
    }

    public function saveTipoctpagarfiliTipoctpagarContctbl(DTO\Request $request, DTO\Response $response) {
        try {
            $row = $request->getDataSet()->getRows()[0];
            $row['__is_new'] = $this->parametrosService->tipoctpagarfiliIsNew($row);
            $this->dataSourceName = "tipoctpagarfili_tipoctpagar_contctbl";
            $this->dataSourceNameToSave = "tipoctpagarfili";
            parent::save($request, $response);
        } catch(\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    }

    public function findTipoajpagarfiliContctblHistpadr(DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName = "tipoajpagar_contctbl_histpadr";
        $this->parameterBagColumns = array("NRORG");
        parent::find($request, $response);
    }

    public function saveTipoajpagarfiliContctblHistpadr(DTO\Request $request, DTO\Response $response) {
        $this->dataSourceName = "tipoajpagar_contctbl_histpadr";
        parent::save($request, $response);
    }


    public function findTipobaixapagHistpadr(DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName = "tipobaixapag_histpadr";
        $this->parameterBagColumns = array("NRORG");
        parent::find($request, $response);
    }

    public function saveTipobaixapagHistpadr(DTO\Request $request, DTO\Response $response) {
        $this->dataSourceName = "tipobaixapag_histpadr";
        parent::save($request, $response);
    }

    public function findTipoctreceberHistpadrContctbl(DTO\Request\Filter $request, DTO\Response $response) {
            $this->dataSourceName = "tipoctreceber_histpadr_contctbl";
            $this->parameterBagColumns = array("NRORG");
            parent::find($request, $response);
    }

    public function saveTipoctreceberHistpadrContctbl(DTO\Request $request, DTO\Response $response) {
        try {
            $row = $request->getDataSet()->getRows()[0];
            $this->parametrosService->validarTipoctreceber($row);
            $this->dataSourceName = "tipoctreceber_histpadr_contctbl";
            parent::save($request, $response);
        } catch(\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    }

    public function findTipoajreceberHistpadrContctbl(DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName = "tipoajreceber_histpadr_contctbl";
        $this->parameterBagColumns = array("NRORG");
        parent::find($request, $response);
    }

    public function saveTipoajreceberHistpadrContctbl(DTO\Request $request, DTO\Response $response) {
        $this->dataSourceName = "tipoajreceber_histpadr_contctbl";
        parent::save($request, $response);
    }

    public function findTipobaixarecHistpadr(DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName = "tipobaixarec_histpadr";
        $this->parameterBagColumns = array("NRORG");
        parent::find($request, $response);
    }

    public function saveTipobaixarecHistpadr(DTO\Request $request, DTO\Response $response) {
        $this->dataSourceName = "tipobaixarec_histpadr";
        parent::save($request, $response);
    }

    public function findTpcredbancHistpadrContctbl(DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName = "tpcredbanc_histpadr_contctbl";
        $this->parameterBagColumns = array("NRORG");
        parent::find($request, $response);
    }

    public function saveTpcredbancHistpadrContctbl(DTO\Request $request, DTO\Response $response) {
        $this->dataSourceName = "tpcredbanc_histpadr_contctbl";
        parent::save($request, $response);
    }

    public function findTpdebibancHistpadrContctbl(DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName = "tpdebibanc_histpadr_contctbl";
        $this->parameterBagColumns = array("NRORG");
        parent::find($request, $response);
    }

    public function saveTpdebibancHistpadrContctbl(DTO\Request $request, DTO\Response $response) {
        $this->dataSourceName = "tpdebibanc_histpadr_contctbl";
        parent::save($request, $response);
    }

    public function findContcorrContctbl(DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName = "contcorr_contctbl";
        $this->parameterBagColumns = array("NRORG");
        parent::find($request, $response);
    }

    public function saveContcorrContctbl(DTO\Request $request, DTO\Response $response) {
        $this->dataSourceName = "contcorr_contctbl";
        parent::save($request, $response);
    }

    public function findFilialContctbl(DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName = "filial_contctbl";
        $this->parameterBagColumns = array("NRORG");
        parent::find($request, $response);
    }

    public function saveFilialContctbl(DTO\Request $request, DTO\Response $response) {
        $this->dataSourceName = "filial_contctbl";
        parent::save($request, $response);
    }

    public function findClienteContctbl(DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName = "cliente_contctbl";
        $this->parameterBagColumns = array("NRORG");
        parent::find($request, $response);
    }

    public function saveClienteContctbl(DTO\Request $request, DTO\Response $response) {
        $this->dataSourceName = "cliente_contctbl";
        parent::save($request, $response);
    }

    public function findFornecedorContctbl(DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName = "fornecedor_contctbl";
        $this->parameterBagColumns = array("NRORG");
        parent::find($request, $response);
    }

    public function saveFornecedorContctbl(DTO\Request $request, DTO\Response $response) {
        $this->dataSourceName = "fornecedor_contctbl";
        parent::save($request, $response);
    }

    public function findParamctblContctbl(DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName = "paramctbl_contctbl";
        $this->parameterBagColumns = array("NRORG");
        parent::find($request, $response);
    }

    public function saveParamctblContctbl(DTO\Request $request, DTO\Response $response) {
        $this->dataSourceName = "paramctbl_contctbl";
        parent::save($request, $response);
    }

    public function findParamempresaContctbl(DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName = "paramempresa_contctbl";
        $this->parameterBagColumns = array("CDEMPRESA", "NRORG");
        parent::find($request, $response);
    }

    public function saveParamempresaContctbl(DTO\Request $request, DTO\Response $response) {
        $this->dataSourceName = "paramempresa_contctbl";
        parent::save($request, $response);
    }

    public function findParamfilialContctbl(DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName = "paramfilial_contctbl";
        $this->parameterBagColumns = array("CDFILIAL", "NRORG");
        parent::find($request, $response);
    }

    public function saveParamfilialContctbl(DTO\Request $request, DTO\Response $response) {
        $this->dataSourceName = "paramfilial_contctbl";
        parent::save($request, $response);
    }

    public function cadastramentoAutomaticoProdutos(DTO\Request $request, DTO\Response $response) {
        try {
            $row = $request->getRow();
            $this->parametrosService->cadastramentoAutomaticoProdutos($row);
        } catch(\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    }

    public function cadastramentoAutomaticoTitulos(DTO\Request $request, DTO\Response $response) {
        try {
            $row = $request->getRow();
            $this->parametrosService->cadastramentoAutomaticoTitulos($row);
        } catch(\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    }

    private function getFilterArray($request) {
        $filter = array();
        $conditions = $request->getFilterCriteria()->getConditions();
        foreach ($conditions as $condition) {
            $filter[$condition["columnName"]] = $condition["value"];
        }
        return $filter;
    }
}